#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef RemailerDlgsH
#define RemailerDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <HttpProt.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Tabs.hpp>
#include "explbtn.hpp"
#include <vcl\Buttons.hpp>
#include "global.h"
#include <vcl\Menus.hpp>
//---------------------------------------------------------------------------
bool  __fastcall GetRemailerStats(TForm *parent, bool attended=true);

class TRemailerDoc : public TStringList
{
public:
   bool OpenDoc,Modified;
   virtual __fastcall TRemailerDoc();
   virtual __fastcall TRemailerDoc(AnsiString Docfile);
};

bool __fastcall FreshenType1(TRemailerDoc *Type1, TRemailerDoc *CRing,
   TRemailerDoc *CList, bool SaveToDisk);
bool __fastcall FreshenType2(TRemailerDoc *Type2, TRemailerDoc *MRing,
   bool SaveToDisk);

class TRemailerDlg : public TForm
{
__published:	// IDE-managed Components
 	 THttpCli *HttpCli1;
   TPanel *Panel2;
   TProgressBar *ProgressBar1;
   TButton *GetDocs;
   TButton *CancelBtn;
   TTimer *Timer1;
   TTimer *Timer2;
   TPanel *Panel1;
   TPageControl *PageControl1;
   TTabSheet *TabSheet1;
   TGroupBox *MixmasterGrp;
   TCheckBox *MTyp2Box;
   TCheckBox *MRingBox;
   TCheckBox *MListBox;
   TGroupBox *CyberpunkGrp;
   TCheckBox *CRingBox;
   TCheckBox *CListBox;
   TButton *UrlsBtn;
   TTabSheet *TabSheet2;
   TLabel *Label2;
   TLabel *Label3;
   TLabel *Label4;
   TLabel *Label5;
   TLabel *Label6;
   TEdit *ProxyHostEdit;
   TEdit *ProxyPortEdit;
   TEdit *ProxyPswdEdit;
   TEdit *ProxyUserEdit;
   TCheckBox *ProxyPswdBox;
   TTabSheet *TabSheet3;
   TTabSet *TabSet;
   TLabel *Label1;
   TButton *OkBtn;
   TTabSheet *TabSheet4;
   TGroupBox *MixErrorGrp;
   TCheckBox *MixSyncTyp2Box;
   TCheckBox *MixRepNewBox;
   TCheckBox *MixUpdRingBox;
   TGroupBox *CpunkErrorGrp;
   TCheckBox *CpunkUpdRingBox;
   TCheckBox *CpunkErrorCheck;
   TCheckBox *MixErrorCheck;
   TCheckBox *CpunkRepNewBox;
   TCheckBox *MixListBox;
   TCheckBox *MixRingBox;
   TCheckBox *MixTyp2Box;
   TLabel *Label8;
   TCheckBox *CpunkListBox;
   TCheckBox *CpunkRingBox;
   TLabel *Label9;
   TLabel *Label10;
   TLabel *Label11;
   TLabel *Label12;
   TLabel *Label13;
   TButton *Button1;
   TCheckBox *CpunkSyncTyp1Box;
   TCheckBox *CpunkTyp1Box;
   TBitBtn *BitBtn2;
   TCheckBox *ErrorCheck;
   TRichEdit *DocMemo;
   TCheckBox *CTyp1Box;
   TRichEdit *RichEdit1;
   TButton *HelpBtn;
   TButton *ProxyBtn;
  TComboBox *MListCBox;
  TComboBox *MRingCBox;
  TComboBox *CListCBox;
  TComboBox *CRingCBox;
  TComboBox *MTyp2CBox;
	TTimer *TimeOutTimer;
  TButton *OpenBtn;
  TButton *DeleteBtn;
  TTimer *Timer3;
	 void __fastcall GetDocsClick(TObject *Sender);
	 void __fastcall HttpCli1DocBegin(TObject *Sender);
	 void __fastcall HttpCli1DocEnd(TObject *Sender);
	 void __fastcall HttpCli1RequestDone(TObject *Sender, THttpRequest RqType, WORD Error);
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall HttpCli1DocData(TObject *Sender, Pointer Buffer, int Len);
   void __fastcall CancelBtnClick(TObject *Sender);
   void __fastcall Timer1Timer(TObject *Sender);
   void __fastcall ProxyPswdBoxClick(TObject *Sender);
   void __fastcall PageControl1Changing(TObject *Sender, bool &AllowChange);
   void __fastcall Timer2Timer(TObject *Sender);
   void __fastcall FormShow(TObject *Sender);
   void __fastcall UrlsBtnClick(TObject *Sender);
   void __fastcall TabSetChange(TObject *Sender, int NewTab, bool &AllowChange);
   void __fastcall FormResize(TObject *Sender);
   void __fastcall ErrorCheckClick(TObject *Sender);
   void __fastcall CRingBoxClick(TObject *Sender);
   void __fastcall MRingBoxClick(TObject *Sender);
   void __fastcall HelpBtnClick(TObject *Sender);
   void __fastcall ProxyBtnClick(TObject *Sender);
   void __fastcall DocCBoxChange(TObject *Sender);
   void __fastcall TimeOutTimerTimer(TObject *Sender);
   void __fastcall OpenRemailerDocClick(TObject *Sender);
   void __fastcall OpenBtnClick(TObject *Sender);
   void __fastcall DeleteBtnClick(TObject *Sender);
  
  void __fastcall Timer3Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
   int TimeOut,CurTime;
   TStrings *Tabs;
   AnsiString CurDoc;
   TCheckBox *CurBox;
   double BytesTotal;
   long BytesReceived;
   AnsiString Cap,Http,MListURL,MRingURL,MTyp2URL,CListURL,CRingURL;
   AnsiString clisttxt,cringtxt,ctyp1txt,mlisttxt,mringtxt,mtyp2txt;
   bool Attended,Cancelled,CancelAnyway,SelfUpdateMix,SelfUpdateCpk;
   __fastcall TRemailerDlg(TComponent* Owner);
   virtual __fastcall ~TRemailerDlg();
   void __fastcall LoadHttpInfo();
   void __fastcall StoreHttpInfo();
   bool __fastcall SaveStatistics();
   void __fastcall SaveErrChkLog(TRemailerDoc *Log);
   bool __fastcall Execute(bool attended);
   void __fastcall InitCheckmarks();
   void __fastcall GetAppURLs();
   void __fastcall LoadURLs();
   void __fastcall SetTabCurrent(AnsiString &TabName, TRemailerDoc *TabDoc);
   AnsiString __fastcall GetDefaultURL(AnsiString &path);
   bool __fastcall GetStatistics(AnsiString &forURL, TCheckBox *Box, AnsiString &Doc);
   void __fastcall ResetCheckboxes();
   int  __fastcall GoodTabs(); // tabcount of good, saveable docs
   bool __fastcall IsTab(int Index, AnsiString &TabName); // does Tab->Strings[index]==TabName
   void __fastcall SetTab(int TabIndex); // set tab's doc to docmemo text
   TRemailerDoc* __fastcall TabDoc(int Index); // if valid, tab's doc, else NULL
   void virtual __fastcall SetDoc(AnsiString DocName, TRemailerDoc *Doc);
   void virtual __fastcall SetDoc(int Index, TRemailerDoc *Doc);
   TRemailerDoc* __fastcall GetDoc(AnsiString DocName);
   TRemailerDoc* __fastcall GetDoc(int Index);
   void __fastcall ResetSelfUpdate();
   bool __fastcall NeedsMixKeysUpdate(TRemailerDoc *MixList);
   bool __fastcall NeedsCpkKeysUpdate(TRemailerDoc *CpkList);
   void __fastcall SetDocMemo(TRemailerDoc *Doc, bool SaveCur=true);
   void __fastcall CheckDocumentsExist();
   void __fastcall ClearDocuments();
   void __fastcall GetBtnClick();
   void __fastcall Display(AnsiString &text); // adds to end
   void __fastcall Displas(AnsiString &text); // write to last line
   TRemailerDoc* __fastcall OpenRemailerDoc(AnsiString &Filename); // open doc for edit
  // error checking
   bool __fastcall CorruptDoc(TRemailerDoc *Doc);
   TRemailerDoc* __fastcall GetDocument(AnsiString &DocName);
   bool __fastcall ReportDocumentsAndProblems();
       // cyberpunk
   bool __fastcall CpkCheckAddNewRemailerKeys(TRemailerDoc *Cring, TRemailerDoc *Type1,
       TRemailerDoc *CList);
   bool __fastcall CpkCheckGenType1(TRemailerDoc *Type1, TRemailerDoc *CRing,
       TRemailerDoc *CList);
   bool __fastcall CpkCheckType1NoDoubles(TRemailerDoc *Type2);
   bool __fastcall CpkCheckListKeyNotFound(TRemailerDoc *CList, TRemailerDoc *Type1);
   bool __fastcall CpkListOk(TRemailerDoc *doctxt);
   bool __fastcall CpkRingOk(TRemailerDoc *doctxt);
       // mixmaster
   bool __fastcall MixCheckAddNewRemailerKeys(TRemailerDoc *MRing, TRemailerDoc *Type2,
      TRemailerDoc *MList);
   bool __fastcall MixCheckGenType2(TRemailerDoc *Type2, TRemailerDoc *MRing);
   bool __fastcall MixCheckType2NoDoubles(TRemailerDoc *Type2);
   bool __fastcall MixCheckListKeyNotFound(TRemailerDoc *MList, TRemailerDoc *Type2);
   bool __fastcall MixListOk(TRemailerDoc *doctxt);
   bool __fastcall MixRingOk(TRemailerDoc *doctxt);
   // message map
   void virtual __fastcall WMGetButtonClick(TMessage& Msg);
   BEGIN_MESSAGE_MAP
   MESSAGE_HANDLER(WM_GETBUTTONCLICK,TMessage,WMGetButtonClick)
   END_MESSAGE_MAP(TForm)
};

const AnsiString ChecksPage = "Error Checks";
const bool save = true;
//---------------------------------------------------------------------------
extern TRemailerDlg *RemailerDlg;
//---------------------------------------------------------------------------
#endif
